
Foreman - Bug #1592

report::expire errors with millions of records

04/30/2012 01:47 PM - Jacob McCann

Status: Closed   

Priority: Normal   

Assignee: Ori Rabin   

Category: Reporting   

Target version: 1.7.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/1659

  

Description

When running report::expire against a DB with millions of records in Reports the 'function' will fail (

https://groups.google.com/d/msg/foreman-users/_Mn4oxXmP7E/kH0ISyjoMhgJ):

Mysql::Error: Got a packet bigger than 'max_allowed_packet' bytes: SELECT id FROM `reports` WHERE 

(`reports`.`id` IN (15462,15463,15464,15465,15466,15467,15468,15469,15470,15471,15475,16252,16256,

16257,16258,16259,16260,16263,16267,16268,16269,16270,16272,16279,16282,16283,16284,16285,16286,16

287,16302,18042,18043,18044,18045,18046,18062,18063,18064,18065,18066,18067,18068,18084,18085,

 Which seems to stem from (https://groups.google.com/d/msg/foreman-users/_Mn4oxXmP7E/EADjgREX3Z4J):

And since the 'bad' query starts with: SELECT id FROM `reports` WHERE (`reports`.`id` IN (15462,15

463,15464,15465 my guess is its specifically line:

  # reports which have logs entries

      used_reports = Report.all(:select => :id, :conditions => {:id => all_reports}).m

  ap(&:id)

 https://groups.google.com/forum/?fromgroups#!topic/foreman-users/_Mn4oxXmP7E

Code to functionally get past this error that I've used is (

https://groups.google.com/d/msg/foreman-users/_Mn4oxXmP7E/lSKWXpW3JoQJ):

    # used_reports = Report.all(:select => :id, :conditions => {:id => all_reports}).map(&:id)

    used_reports = []

    tmp_arr=all_reports.dup

    slice_size = 10000

    until tmp_arr.empty? do

      first = (tmp_arr.size < slice_size) ? 0 : (tmp_arr.size - slice_size)

      last = tmp_arr.size

      tmp = tmp_arr[first..last]

      used_reports << Report.all(:select => :id, :conditions => {:id => tmp}).map(&:id)

      tmp_arr = tmp_arr - tmp

    end

    used_reports.flatten!.sort

Related issues:

Related to Foreman - Bug #8565: report::expire is running very slowly Closed 12/03/2014

Has duplicate Foreman - Bug #1546: report::expire slow with many reports Duplicate

Associated revisions

Revision 4215defb - 08/07/2014 10:03 AM - Ori Rabin

Fixes #1592: making report::expire faster and without errors
Revision ab866a31 - 09/15/2014 07:27 AM - Ori Rabin

Fixes #1592: making report::expire faster and without errors

History

#1 - 11/13/2012 12:11 PM - Greg Sutcliffe

- Target version set to Bug scrub

#2 - 10/16/2013 04:04 PM - Greg Sutcliffe

- Target version deleted (Bug scrub)

#3 - 07/30/2014 09:14 AM - Ohad Levy

- Target version set to 1.7.5

#4 - 08/06/2014 06:55 AM - Ori Rabin

- Has duplicate Bug #1546: report::expire slow with many reports added

#5 - 08/06/2014 06:55 AM - Ori Rabin

- Description updated

- Status changed from New to Assigned

- Assignee set to Ori Rabin

#6 - 08/07/2014 03:34 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/1659 added

- Pull request deleted ()

#7 - 08/07/2014 10:07 AM - Dominic Cleal

- translation missing: en.field_release set to 10

#8 - 08/07/2014 10:19 AM - Dominic Cleal

- translation missing: en.field_release deleted (10)

#9 - 08/07/2014 11:01 AM - Ori Rabin

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 4215defb81fc2b469669592ac1094d7c70950192.

#10 - 08/07/2014 11:03 AM - Dominic Cleal

- Status changed from Closed to Ready For Testing

- % Done changed from 100 to 0

Commit was reverted (https://github.com/theforeman/foreman/commit/bf1d8e08a928a72f879911225afb21d103895e5b) and the PR re-opened as

issues were raised.

#11 - 08/20/2014 06:48 AM - Anonymous

- Target version changed from 1.7.5 to 1.7.4

#12 - 09/10/2014 07:18 AM - Anonymous

- Target version changed from 1.7.4 to 1.7.3

#13 - 09/15/2014 07:28 AM - Dominic Cleal

- translation missing: en.field_release set to 21

#14 - 09/15/2014 08:01 AM - Ori Rabin

- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset ab866a3185b132555e1eed393f8de6c5a9a729c4.

#15 - 09/21/2014 01:40 AM - Daniel Lobato Garcia

Any reasons why this can't go in 1.6.1? Releasing this in 1.6.1 would help us find possible bugs before 1.7.

#16 - 09/22/2014 04:17 AM - Dominic Cleal

Daniel Lobato Garcia wrote:

Any reasons why this can't go in 1.6.1? Releasing this in 1.6.1 would help us find possible bugs before 1.7.

 That's the wrong way around.. 1.6.1 should be a minimum risk & stable release, giving us time in pre-1.7 testing to find bugs.  Point releases are not

for experiments.

Given this has already been reverted once, I think it's moderate risk so probably unsuitable.

#17 - 12/05/2014 03:16 AM - Dominic Cleal

- Related to Bug #8565: report::expire is running very slowly added

#18 - 12/21/2015 04:01 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/2994 added

#19 - 12/21/2015 04:02 AM - Ori Rabin

- Pull request deleted (https://github.com/theforeman/foreman/pull/2994)
